// MyList.cpp : implementation file
//

#include "stdafx.h"
#include "NoteIt.h"
#include "MyList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyList

MyList::MyList()
{
	isDrag=false;
}

MyList::~MyList()
{
}


BEGIN_MESSAGE_MAP(MyList, CListCtrl)
	//{{AFX_MSG_MAP(MyList)
	ON_WM_LBUTTONUP()
	ON_NOTIFY_REFLECT(LVN_BEGINDRAG, OnBegindrag)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyList message handlers

void MyList::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	isDrag=false;
	CListCtrl::OnLButtonUp(nFlags, point);
}

void MyList::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	isDrag=true;
	//dragItem=pNMListView->iItem;
	dragItem=0;
	startX=pNMListView->ptAction.x;
	startY=pNMListView->ptAction.y;
	POINT pt;
	
	POSITION pos = GetFirstSelectedItemPosition();
	while (1)
	{
		if(!pos) break;
		itemIndex[dragItem] = GetNextSelectedItem(pos);
		GetItemPosition(itemIndex[dragItem], &item[dragItem]);
		dragItem++;
	}
	
	//itemX=pt.x;
	//itemY=pt.y;
	*pResult = 0;
}

void MyList::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(isDrag)
	{
		POINT pt,delta;
		delta.x=(point.x-startX);
		delta.y=(point.y-startY);
		for(int i=0; i<dragItem; i++)
		{
			pt.x=delta.x+item[i].x;
			pt.y=delta.y+item[i].y;
			SetItemPosition(itemIndex[i], pt);
		}
		
		
		CListCtrl::OnMouseMove(nFlags, point);
	}
}


void MyList::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CListCtrl::OnLButtonDown(nFlags, point);
}
