// NoteItDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NoteIt.h"
#include "NoteItDlg.h"
#include "EditNote.h"
#include "MyList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CNoteItApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoteItDlg dialog

CNoteItDlg::CNoteItDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNoteItDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNoteItDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNoteItDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNoteItDlg)
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNoteItDlg, CDialog)
	//{{AFX_MSG_MAP(CNoteItDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_LIST, OnEndlabeleditList)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_WM_KEYUP()
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST, OnKeydownList)
	ON_WM_LBUTTONUP()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_ARRANGE, OnArrange)
	ON_BN_CLICKED(IDC_DONE, OnDone)
	ON_BN_CLICKED(IDC_UNDO, OnUndo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoteItDlg message handlers

BOOL CNoteItDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	imgList.Create(32,32, TRUE, 4, 4);
	imgList.Add(theApp.LoadIcon(IDI_ICON1));
		
	m_List.SetImageList(&imgList, LVSIL_NORMAL);
	CFile file("data.dat", CFile::modeRead);
	CArchive archive(&file, CArchive::load);
	int count;
	archive >> count;
	textArray.SetSize(count);
	for(int i=0; i<count; i++)
	{
		CString str;
		archive >> str;
		POINT pt;
		archive >> pt.x >> pt.y;
		archive >> textArray[i];
		m_List.InsertItem(i,str,0);
		m_List.SetItemPosition(i, pt);

	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNoteItDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNoteItDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNoteItDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CNoteItDlg::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	NMLISTVIEW *p = (NMLISTVIEW *)pNMHDR;
	//m_List.SetItemText(p->iItem , 0, "Hello There");
	if(p->iItem!=-1)
	{
		CEditNote note(&(textArray[p->iItem]));
		note.DoModal();
	}
	
	*pResult = 0;
}

void CNoteItDlg::OnOK() 
{
	// TODO: Add extra validation here

	writeNotes();
	DestroyWindow();
	//CDialog::OnOK();
}

void CNoteItDlg::OnEndlabeleditList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = true;
}

void CNoteItDlg::OnNew() 
{
	m_List.InsertItem(m_List.GetItemCount(), "New Item", 0);
	textArray.Add("");
	//m_List.Arrange(LVA_DEFAULT);
}

void CNoteItDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CNoteItDlg::OnKeydownList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if(pLVKeyDow->wVKey==46) 
	{
		
		while (1)
		{
			  POSITION pos = m_List.GetFirstSelectedItemPosition();
			  if(!pos) break;
			  int nItem = m_List.GetNextSelectedItem(pos);
			  
			  m_List.DeleteItem(nItem);
			  textArray.RemoveAt(nItem);

		}
	

	} 
	//m_List.Arrange(LVA_DEFAULT);
	*pResult = 0;
}


void CNoteItDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CNoteItDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	writeNotes();
	CDialog::OnClose();
}

void CNoteItDlg::OnArrange() 
{
	// TODO: Add your control notification handler code here
	m_List.Arrange(LVA_SNAPTOGRID);
}

void CNoteItDlg::OnDone() 
{
	// TODO: Add your control notification handler code here
	//writeNotes();
	//DestroyWindow();
	CDialog::OnOK();
}

BOOL CNoteItDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	writeNotes();
	return CDialog::DestroyWindow();
}

void CNoteItDlg::writeNotes()
{
	CFile file("data.dat", CFile::modeWrite | CFile::modeCreate);
	CArchive archive(&file, CArchive::store);
	int count = m_List.GetItemCount();
	archive << count;
	for(int i=0; i<count; i++)
	{
		archive << m_List.GetItemText(i,0);
		//textArray[i]="";
		//CString str = "";
		POINT pt;
		m_List.GetItemPosition(i, &pt);
		archive << pt.x << pt.y;
		archive << textArray[i];
	}	
}

void CNoteItDlg::OnUndo() 
{
	// TODO: Add your control notification handler code here
	m_List.DeleteAllItems();
	CFile file("data.dat", CFile::modeRead);
	CArchive archive(&file, CArchive::load);
	int count;
	archive >> count;
	textArray.SetSize(count);
	for(int i=0; i<count; i++)
	{
		CString str;
		archive >> str;
		POINT pt;
		archive >> pt.x >> pt.y;
		archive >> textArray[i];
		m_List.InsertItem(i,str,0);
		m_List.SetItemPosition(i, pt);

	}	
}
